//this program read from the pattern table and crates a list of ranks
package pattern;

import ranktable.Rank;
import java.sql.*;
import java.util.*;

//String host = "jdbc:mysql://localhost:8889/";
public class patternConsult {

    static String className = "com.mysql.jdbc.Driver";
    static String host = "jdbc:mysql://localhost:8889/"; //name of the host where it is DB service and port
    static String dataBase = "Project"; //database name
    static String user = "root";
    static String password = "root";

    //save all the registers from the table in a LinkedList
    public static String getPatterns() { //save all the registers from the table in a LinkedList
        LinkedList<Pattern> PatternsList = new LinkedList<Pattern>();
        try {
            Class.forName(className).newInstance();
            Connection conexion = DriverManager.getConnection(host + dataBase, user, password);
            Statement st = conexion.createStatement();
            ResultSet rs = st.executeQuery("select * from pattern"); //select all registers from DB
            while (rs.next()) // while exist more register I save in patternlist
            {
                Pattern pattern = new Pattern();
                pattern.setId(rs.getInt("id"));
                pattern.setName(rs.getString("name")); //the name between the "" is the name of the column
                pattern.setName_EN(rs.getString("name_EN"));
                pattern.setDescription(rs.getString("description"));
                pattern.setDescription_EN(rs.getString("description_EN"));
                pattern.setId_Rank(rs.getInt("id_rank"));
                pattern.setDiagram_Id_Number(rs.getInt("diagram_id_number"));
                pattern.setDiagram_Rows(rs.getInt("diagram_rows"));
                pattern.setDiagram_Columns(rs.getInt("diagram_columns"));
                PatternsList.add(pattern); //add pattern to the list
            }
            rs.close(); //close query sql
            st.close();// close statment
            conexion.close(); // close conexion with DB


        } catch (Exception e) {
            e.printStackTrace();
        }
        return patternResult(PatternsList);
    }

    //makes the toString f the list received
    public static String patternResult(LinkedList<Pattern> list) {
        String result = "<h1>Content of table Pattern</h1>" +
                "<table >" +
                "<tr>" +
                "<td> Id </td>" +
                "<td> Name </td>" + //names of the column
                "<td> Name in English </td>" +
                "<td> Description </td>" +
                "<td> Description in English </td>" +
                "<td> Id Rank </td>" +
                "<td> Diagram Id Number </td>" +
                "<td> Diagram Rows </td>" +
                "<td> Diagram Columns </td>" +
                "</tr>";

        for (int i = 0; i < list.size(); i++) { //scan the list saving all the registers in a string
            result = result + "<tr>";
            result = result + "<td>" + list.get(i).getId() + "</td>";
            result = result + "<td>" + list.get(i).getName() + "</td>";
            result = result + "<td>" + list.get(i).getName_EN() + "</td>";
            result = result + "<td>" + list.get(i).getDescription() + "</td>";
            result = result + "<td>" + list.get(i).getDescription_EN() + "</td>";
            result = result + "<td>" + list.get(i).getId_Rank() + "</td>";
            result = result + "<td>" + list.get(i).getDiagram_Id_Number() + "</td>";
            result = result + "<td>" + list.get(i).getDiagram_Rows() + "</td>";
            result = result + "<td>" + list.get(i).getDiagram_Columns() + "</td>";

            result = result + "</tr>";
        }

        result = result + "</table>";
        return result;
    }

    //stored in a String all the records that have a parameter like this.
    public static String findPatterns(int id, String name, String name_EN, String description, String description_EN, int id_rank, int diagram_id_number, int diagram_rows, int diagram_columns) {
        LinkedList<Pattern> PatternsList = new LinkedList<Pattern>();
        String result = "";

        try {

            Class.forName(className).newInstance();
            Connection conexion = DriverManager.getConnection(host + dataBase, user, password);
            Statement st = conexion.createStatement();
            ResultSet rst = st.executeQuery( //search registers who has the same id, name,name_EN,description...
                    "select * " +
                    "from pattern " +
                    "where (id = '" + id + "' " +
                    "OR name = '" + name + "' " +
                    "OR name_EN = '" + name_EN + "' )" +
                    "OR description = '" + description + "'" +
                    "OR description_EN = '" + description_EN + "' " +
                    "OR id_rank = '" + id_rank + "' " +
                    "OR diagram_id_number = '" + diagram_id_number + "' " +
                    "OR diagram_rows = '" + diagram_rows + "' " +
                    "OR diagram_columns = '" + diagram_columns + "' ");
            while (rst.next()) // while exist more register I save in PatternsList
            {
                Pattern pattern = new Pattern();
                pattern.setId(rst.getInt("id"));
                pattern.setName(rst.getString("name")); //the name between the "" is the name of the column
                pattern.setName_EN(rst.getString("name_EN"));
                pattern.setDescription(rst.getString("description"));
                pattern.setDescription_EN(rst.getString("description_EN"));
                pattern.setId_Rank(rst.getInt("id_rank"));
                pattern.setDiagram_Id_Number(rst.getInt("diagram_id_number"));
                pattern.setDiagram_Rows(rst.getInt("diagram_rows"));
                pattern.setDiagram_Columns(rst.getInt("diagram_columns"));
                PatternsList.add(pattern); //add pattern to the list
            }
            rst.close(); //close query sql
            st.close();// close statment
            conexion.close(); // close conexion with DB
            // List records to change. Choose one to change it and Change the parameters

            result = "<form method=\"post\" action=\"editPattern.jsp\" name=\"formChoosePattern\">" +
                    "<h1>Content of table pattern</h1>" +
                    "<table >" +
                    "<tr>" +
                    "<td>Choose</td>" +
                    "<td> Id </td>" +
                    "<td> Name </td>" + //names of the column
                    "<td> Name in English </td>" +
                    "<td> Description </td>" +
                    "<td> Description in English </td>" +
                    "<td> Id Rank </td>" +
                    "<td> Diagram Id Number </td>" +
                    "<td> Diagram Rows </td>" +
                    "<td> Diagram Columns </td>" +
                    "</tr>";

            for (int i = 0; i < PatternsList.size(); i++) {
                result = result + "<tr>";
                result = result + "<td> <input name=\"id\" type=\"radio\" value=\"" + PatternsList.get(i).getId() + "\"  checked=\"yes\"></td>";
                result = result + "<td>" + PatternsList.get(i).getId() + "</td>";
                result = result + "<td>" + PatternsList.get(i).getName() + "</td>";
                result = result + "<td>" + PatternsList.get(i).getName_EN() + "</td>";
                result = result + "<td>" + PatternsList.get(i).getDescription() + "</td>";
                result = result + "<td>" + PatternsList.get(i).getDescription_EN() + "</td>";
                result = result + "<td>" + PatternsList.get(i).getId_Rank() + "</td>";
                result = result + "<td>" + PatternsList.get(i).getDiagram_Id_Number() + "</td>";
                result = result + "<td>" + PatternsList.get(i).getDiagram_Rows() + "</td>";
                result = result + "<td>" + PatternsList.get(i).getDiagram_Columns() + "</td>";
                result = result + "</tr>";
            }

            result = result + "</table>" +
                    "<input type=\"submit\" name=\"edit\" value=\"Edit\">" +
                    "<input type=\"reset\" value=\"Reset\"> " +
                    "</form>";

        } catch (Exception e) {
            e.printStackTrace();
        }
        return result;
    }

    // search the register id like the id searched and change the values of this register by the new
    public static void patternUpdate(int id, String newName, String newName_EN, String newDescription, String newDescription_EN, int newId_rank, int newDiagram_id_number, int newDiagram_rows, int newDiagram_columns) {
        try {
            Class.forName(className).newInstance();
            Connection conn = DriverManager.getConnection(host + dataBase, user, password);
            Statement st = conn.createStatement();
            ResultSet rst = st.executeQuery(
                    "select * " +
                    "from pattern " +
                    "where id = '" + id + "'");

            rst.next();
            Pattern pattern = new Pattern();

            pattern.setName(rst.getString("name"));
            pattern.setName_EN(rst.getString("name_en"));
            pattern.setDescription(rst.getString("description"));
            pattern.setDescription_EN(rst.getString("description_EN"));
            pattern.setId_Rank(rst.getInt("id_rank"));
            pattern.setDiagram_Id_Number(rst.getInt("diagram_id_number"));
            pattern.setDiagram_Rows(rst.getInt("diagram_rows"));
            pattern.setDiagram_Columns(rst.getInt("diagram_columns"));
            

            if ("".equals(newName) || newName == null) { //if newName is empty, it save the old value
                newName = pattern.name;
            }
            if (newName_EN.equals("") || newName_EN == null) {//if newName_EN is empty, it save the old value

                newName_EN = pattern.name_EN;
            }
            if (newDescription.equals("") || newDescription == null) { //if newDescription is empty, it save the old value

                newDescription = pattern.description;
            }
            if (newDescription_EN.equals("") || newDescription_EN == null) { //if newDescription_EN is empty, it save the old value

                newDescription_EN = pattern.description_EN;
            }

            if (newId_rank < 0) {
                newId_rank = pattern.id_rank;
            }
            if (newDiagram_id_number < 0) {
                newDiagram_id_number = pattern.diagram_id_number;
            }
            if (newDiagram_rows < 0) {
                newDiagram_rows = pattern.diagram_rows;
            }
            if (newDiagram_columns < 0) {
                newDiagram_columns = pattern.diagram_columns;
            }

            rst.close();
            st.close();
            conn.close();

            Class.forName(className).newInstance();
            // jdbc:mysql://[servidor]:[puerto]/[base de datos], usuario, contraseña
            Connection con = DriverManager.getConnection(host + dataBase, user, password);

            // create Statement
            Statement stmt = con.createStatement();
            // create the SQL query

            stmt.executeUpdate( //	modifying the parameters to new values.
                    "UPDATE pattern " +
                    "SET name = '" + newName + "'," +
                    "name_EN = '" + newName_EN + "'," +
                    "description = '" + newDescription + "' ," +
                    "description_EN = '" + newDescription_EN + "', " +
                    "id_rank = '" + newId_rank + "' ," +
                    "diagram_id_number = '" + newDiagram_id_number + "' ," +
                    "diagram_rows = '" + newDiagram_rows + "', " +
                    "diagram_columns = '" + newDiagram_columns + "' " +
                    "WHERE id = '" + id + "'");


            stmt.close();
            // close conexion
            con.close();

        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    //Create a new pattern
    public static void patternCreate(String name, String name_EN, String description, String description_EN, int id_rank, int diagram_id_number, int diagram_rows, int diagram_columns) {

        //si apanyamos el pattern_create.jsp esta funcion no nos hace falta para nada.
        try {
            if (name != null || description != null || id_rank > -1 || diagram_id_number > -1 || diagram_rows > -1 || diagram_columns > -1) {
                if (!"".equals(name) || !"".equals(description)) {

                    Class.forName(className);//.newInstance();
                    Connection conexion = DriverManager.getConnection(host + dataBase, user, password);
                    Statement st = conexion.createStatement();
                    st.executeUpdate("INSERT INTO pattern (id , name ,name_EN , description, description_EN, id_rank, diagram_id_number, diagram_rows, diagram_columns)" +
                            " VALUES ( NULL , '" + name + "', '" + name_EN + "', '" + description + "', '" + description_EN + "','" + id_rank + "','" + diagram_id_number + "','" + diagram_rows + "','" + diagram_columns + "')");


                    st.close();// close statment
                    conexion.close();
                }// close conexion with DB
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    //if confirm is false, list all the registers to delete
    //if confirm is true, delete all the registers
    public static String patternDelete(String[] id, boolean confirm) {
        String result = "";
        try {

            Class.forName(className).newInstance();
            Connection conn = DriverManager.getConnection(host + dataBase, user, password);

            if (!confirm) { //list the registers

                result = "<h2>Are this the patterns that you want to delete?</h2>" +
                        "<table >" +
                        "<tr>" +
                        "<td> Id </td>" +
                        "<td> Name </td>" + //names of the column
                        "<td> Name in English </td>" +
                        "<td> Description </td>" +
                        "<td> Description in English </td>" +
                        "<td> Id Rank </td>" +
                        "<td> Diagram Id Number </td>" +
                        "<td> Diagram Rows </td>" +
                        "<td> Diagram Columns </td>" +
                        "</tr>";

                int temp;

                for (int i = 0; i < id.length; i++) { //read the array
                    Statement st = conn.createStatement();
                    temp = Integer.parseInt(id[i]);

                    ResultSet rs = st.executeQuery(
                            "SELECT * FROM pattern WHERE id = '" + temp + "'"); //search the regsiter wich id is the same that id[i]
                    rs.next();

                    Pattern pattern = new Pattern(); //save the register in the patternList
                    pattern.setId(rs.getInt("id"));
                    pattern.setName(rs.getString("name"));
                    pattern.setName_EN(rs.getString("name_en"));
                    pattern.setDescription(rs.getString("description"));
                    pattern.setDescription_EN(rs.getString("description_EN"));
                    pattern.setId_Rank(rs.getInt("id_rank"));
                    pattern.setDiagram_Id_Number(rs.getInt("diagram_id_number"));
                    pattern.setDiagram_Rows(rs.getInt("diagram_rows"));
                    pattern.setDiagram_Columns(rs.getInt("diagram_columns"));


                    result = result + "<tr>"; //save the pattern in the string result
                    result = result + "<td>" + pattern.getId() + "</td>";
                    result = result + "<td>" + pattern.getName() + "</td>";
                    result = result + "<td>" + pattern.getName_EN() + "</td>";
                    result = result + "<td>" + pattern.getDescription() + "</td>";
                    result = result + "<td>" + pattern.getDescription_EN() + "</td>";
                    result = result + "<td>" + pattern.getId_Rank() + "</td>";
                    result = result + "<td>" + pattern.getDiagram_Id_Number() + "</td>";
                    result = result + "<td>" + pattern.getDiagram_Rows() + "</td>";
                    result = result + "<td>" + pattern.getDiagram_Columns() + "</td>";
                    result = result + "</tr>";

                    rs.close(); //close query sql
                    st.close();// close statment
                }

                result = result + //form for accept or edit the list of registers to delete
                        "</table> " +
                        "<form method=\"post\" action=\"deletePattern.jsp\" name=\"ConfirmDeletePattern\">" +
                        "<input type=\"submit\" name=\"accept\" value=\"Accept\">" +
                        "<input type=\"submit\" name=\"edit\" value=\"Edit\">" +
                        "</form>";

                conn.close(); // close conexiion with DB

            }

            Class.forName(className).newInstance();
            Connection connect = DriverManager.getConnection(host + dataBase, user, password);

            Statement stt = connect.createStatement();

            if (confirm) { // if the list of registers is correct, confirm is true
                for (int i = 0; i < id.length; i++) { //read the array
                    stt.executeUpdate( //delete the register which id is the same that id[i]
                            "DELETE FROM pattern " +
                            "WHERE id = '" + id[i] + "'");
                }
                result = "Save Succesfull";
            }
            stt.close();
            connect.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
        return result;
    }

    // send array of string where I can obtain all the arrays to delete.
    public static String choosePattern() {

        LinkedList<Pattern> PatternsList = new LinkedList<Pattern>();
        String result = "";

        try {

            Class.forName(className).newInstance();
            Connection conexion = DriverManager.getConnection(host + dataBase, user, password);
            Statement st = conexion.createStatement();
            ResultSet rst = st.executeQuery("select * from pattern");
            while (rst.next()) // while exist more register I save in PatternsList
            {
                Pattern pattern = new Pattern();
                pattern.setId(rst.getInt("id"));
                pattern.setName(rst.getString("name"));
                pattern.setName_EN(rst.getString("name_en"));
                pattern.setDescription(rst.getString("description"));
                pattern.setDescription_EN(rst.getString("description_EN"));
                pattern.setId_Rank(rst.getInt("id_rank"));
                pattern.setDiagram_Id_Number(rst.getInt("diagram_id_number"));
                pattern.setDiagram_Rows(rst.getInt("diagram_rows"));
                pattern.setDiagram_Columns(rst.getInt("diagram_columns"));
                PatternsList.add(pattern); //add pattern to the list
            }

            rst.close(); //close query sql
            st.close();// close statment
            conexion.close(); // close conexion with DB
            result = "<form method=\"post\" action=\"confirmDeletePattern.jsp\" name=\"formDeletePattern\">" +
                    "<h1>Content of table pattern</h1>" +
                    "<table >" +
                    "<tr>" +
                    "<td>Choose</td>" +
                    "<td> Id </td>" +
                    "<td> Name </td>" + //names of the column
                    "<td> Name in English </td>" +
                    "<td> Description </td>" +
                    "<td> Description in English </td>" +
                    "<td> Id Rank </td>" +
                    "<td> Diagram Id Number </td>" +
                    "<td> Diagram Rows </td>" +
                    "<td> Diagram Columns </td>" +
                    "</tr>";

            for (int i = 0; i < PatternsList.size(); i++) {
                result = result + "<tr>";
                result = result + "<td> <input type=\"checkbox\" name=\"id\" value=\"" + PatternsList.get(i).getId() + "\"></td>";
                result = result + "<td>" + PatternsList.get(i).getId() + "</td>";
                result = result + "<td>" + PatternsList.get(i).getName() + "</td>";
                result = result + "<td>" + PatternsList.get(i).getName_EN() + "</td>";
                result = result + "<td>" + PatternsList.get(i).getDescription() + "</td>";
                result = result + "<td>" + PatternsList.get(i).getDescription_EN() + "</td>";
                result = result + "<td>" + PatternsList.get(i).getId_Rank() + "</td>";
                result = result + "<td>" + PatternsList.get(i).getDiagram_Id_Number() + "</td>";
                result = result + "<td>" + PatternsList.get(i).getDiagram_Rows() + "</td>";
                result = result + "<td>" + PatternsList.get(i).getDiagram_Columns() + "</td>";
                result = result + "</tr>";
            }

            result = result +
                    "</table> " +
                    "<input type=\"submit\" name=\"delete\" value=\"Delete\">" +
                    "</form>";

        } catch (Exception e) {
            e.printStackTrace();
        }

        return result;
    }

    public static String listOfRanks() {
        String result = "";

        LinkedList<Rank> RanksList = new LinkedList<Rank>();
        try {
            Class.forName(className).newInstance();
            Connection conexion = DriverManager.getConnection(host + dataBase, user, password);
            Statement st = conexion.createStatement();
            ResultSet rst = st.executeQuery("select * from rank");
            while (rst.next()) // while exist more register I save in RanksList
            {
                Rank rank = new Rank();
                rank.setId(rst.getInt("id"));
                rank.setColour(rst.getString("colour"));
                rank.setColour_en(rst.getString("colour_en"));
                rank.setRank_name(rst.getString("rank_name"));
                RanksList.add(rank); //add rank to the list
            }

            rst.close(); //close query sql
            st.close();// close statment
            conexion.close(); // close conexion with DB

            result = "Id Rank <select name =\"id_rank\" size=\"" + RanksList.size() + "\">";

            for (int i = 0; i < RanksList.size(); i++) {
                result = result + "<option value=\"" + RanksList.get(i).getId() + "\"> " + RanksList.get(i).getColour() + "";
            }
            result = result + "</select><br>";
        } catch (Exception e) {
            e.printStackTrace();
        }

        return result;
    }

    /*public static void main(String[] args) {

    LinkedList<Pattern> PatternsList = new LinkedList<Pattern>();
    int id = 3;
    String newName = "BBBBB";
    String newName_EN = "";
    String newDescription = "";
    String newDescription_EN = "";
    int newId_rank = 1;
    int newDiagram_id_number = 2;
    int newDiagram_rows = 3;
    int newDiagram_columns = 4;

    //String[] ids = {"27", "28", "29"};

    patternUpdate(id, newName, newName_EN, newDescription, newDescription_EN, newId_rank, newDiagram_id_number,newDiagram_rows,newDiagram_columns);
    //System.out.println(patternDelete(ids, true));
    //System.out.println(findRanks(id, colour, colour_EN, rank_name));
    //System.out.println(id + "  " + colour + "  " + colour_EN + "  " + rank_name);
    //patternConsult.patternDelete(id);
    String list = patternConsult.getPatterns();
    System.out.println(list);

    }*/
}
