//this program read from the rank table and crates a list of ranks
package ranktable;

import java.sql.*;
import java.util.*;

//String host = "jdbc:mysql://localhost:8889/";
public class rankConsult {

    static String className = "com.mysql.jdbc.Driver";
    static String host = "jdbc:mysql://localhost:8889/"; //name of the host where it is DB service and port
    static String dataBase = "Project"; //database name
    static String user = "root";
    static String password = "root";

    //save all the registers from the table in a LinkedList
    public static String getRanks() { //save all the registers from the table in a LinkedList
        LinkedList<Rank> RanksList = new LinkedList<Rank>();
        try {
            Class.forName(className).newInstance();
            Connection conexion = DriverManager.getConnection(host + dataBase, user, password);
            Statement st = conexion.createStatement();
            ResultSet rs = st.executeQuery("select * from rank"); //select all registers from DB
            while (rs.next()) // while exist more register I save in ranklist
            {
                Rank rank = new Rank();
                rank.setId(rs.getInt("id"));
                rank.setColour(rs.getString("colour")); //the name between the "" is the name of the column
                rank.setColour_en(rs.getString("colour_en"));
                rank.setRank_name(rs.getString("rank_name"));
                RanksList.add(rank); //add rank to the list
            }
            rs.close(); //close query sql
            st.close();// close statment
            conexion.close(); // close conexion with DB


        } catch (Exception e) {
            e.printStackTrace();
        }
        return rankResult(RanksList);
    }

    //makes the toString f the list received
    public static String rankResult(LinkedList<Rank> list) {
        String result = "<h1>Content of table rank</h1>" +
                "<table >" +
                "<tr>" +
                "<td> id </td>" +
                "<td> color </td>" + //names of the column
                "<td> color_en </td>" +
                "<td> rank_name</td>" +
                "</tr>";

        for (int i = 0; i < list.size(); i++) { //scan the list saving all the registers in a string
            result = result + "<tr>";
            result = result + "<td>" + list.get(i).getId() + "</td>";
            result = result + "<td>" + list.get(i).getColour() + "</td>";
            result = result + "<td>" + list.get(i).getColour_en() + "</td>";
            result = result + "<td>" + list.get(i).getRank_name() + "</td>";
            result = result + "</tr>";
        }

        result = result + "</table>";
        return result;
    }

    //stored in a String all the records that have a parameter like this.
    public static String findRanks(int id, String colour, String colour_EN, String rank_name) {
        LinkedList<Rank> RanksList = new LinkedList<Rank>();
        String result = "";

        try {

            Class.forName(className).newInstance();
            Connection conexion = DriverManager.getConnection(host + dataBase, user, password);
            Statement st = conexion.createStatement();
            ResultSet rst = st.executeQuery( //search registers who has the same colour, or colour_EN or rank_name
                    "select * " +
                    "from rank " +
                    "where (id = '" + id + "' " +
                    "OR colour = '" + colour + "' " +
                    "OR colour_EN = '" + colour_EN + "' )" +
                    "OR rank_name = '" + rank_name + "'");
            while (rst.next()) // while exist more register I save in RanksList
            {
                Rank rank = new Rank();
                rank.setId(rst.getInt("id"));
                rank.setColour(rst.getString("colour")); //the name between the "" is the name of the column
                rank.setColour_en(rst.getString("colour_en"));
                rank.setRank_name(rst.getString("rank_name"));
                RanksList.add(rank); //add rank to the list
            }
            rst.close(); //close query sql
            st.close();// close statment
            conexion.close(); // close conexion with DB
            // List records to change. Choose one to change it and Change the parameters

            result = "<form method=\"post\" action=\"editRank.jsp\" name=\"formChooseRank\">" +
                    "<h1>Content of table rank</h1>" +
                    "<table >" +
                    "<tr>" +
                    "<td>Choose</td>" +
                    "<td> id </td>" +
                    "<td> color </td>" +
                    "<td> color_en </td>" +
                    "<td> rank_name</td>" +
                    "</tr>";

            for (int i = 0; i < RanksList.size(); i++) {
                result = result + "<tr>";
                result = result + "<td> <input name=\"id\" type=\"radio\" value=\"" + RanksList.get(i).getId() + "\"></td>";
                result = result + "<td>" + RanksList.get(i).getId() + "</td>";
                result = result + "<td>" + RanksList.get(i).getColour() + "</td>";
                result = result + "<td>" + RanksList.get(i).getColour_en() + "</td>";
                result = result + "<td>" + RanksList.get(i).getRank_name() + "</td>";
                result = result + "</tr>";
            }

            result = result + "</table>" +
                    "<input type=\"submit\" name=\"edit\" value=\"Edit\">" +
                    "<input type=\"reset\" value=\"Reset\"> " +
                    "</form>";

        } catch (Exception e) {
            e.printStackTrace();
        }
        return result;
    }

    // search the register id like the id searched and change the values of this register by the new
    public static void rankUpdate(int id, String newColour, String newColour_EN, String newRank_name) {
        try {
            Class.forName(className).newInstance();
            Connection conn = DriverManager.getConnection(host + dataBase, user, password);
            Statement st = conn.createStatement();
            ResultSet rst = st.executeQuery(
                    "select * " +
                    "from rank " +
                    "where id = '" + id + "'");

            rst.next();
            Rank rank = new Rank();

            rank.setColour(rst.getString("colour"));
            rank.setColour_en(rst.getString("colour_en"));
            rank.setRank_name(rst.getString("rank_name"));

            if ("".equals(newColour) || newColour == null) { //if newColour is empty, it save the old value
                newColour = rank.colour;
            }
            if (newColour_EN.equals("") || newColour_EN == null) {//if newColour_EN is empty, it save the old value

                newColour_EN = rank.colour;
            }
            if (newRank_name.equals("") || newRank_name == null) { //if newRank_Name is empty, it save the old value

                newRank_name = rank.rank_name;
            }

            rst.close();
            st.close();
            conn.close();

            Class.forName(className).newInstance();
            // jdbc:mysql://[servidor]:[puerto]/[base de datos], usuario, contraseña
            Connection con = DriverManager.getConnection(host + dataBase, user, password);

            // create Statement
            Statement stmt = con.createStatement();
            // create the SQL query

            stmt.executeUpdate( //	modifying the parameters to new values.
                    "UPDATE rank " +
                    "SET colour = '" + newColour + "'," +
                    "colour_EN = '" + newColour_EN + "'," +
                    "rank_name = '" + newRank_name + "'" +
                    "WHERE id = '" + id + "'");


            stmt.close();
            // close conexion
            con.close();

        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    //Create a new rank
    public static void rankCreate(String colour, String colour_EN, String rank_name) {
        //si apanyamos el rank_create.jsp esta funcion no nos hace falta para nada.
        try {
            if (colour != null || colour_EN != null || rank_name != null || !"".equals(colour) || !"".equals(colour_EN) || !"".equals(rank_name)) {

                Class.forName(className);//.newInstance();
                Connection conexion = DriverManager.getConnection(host + dataBase, user, password);
                Statement st = conexion.createStatement();
                st.executeUpdate("INSERT INTO rank (id , colour ,colour_EN , rank_name)" +
                        " VALUES ( NULL , '" + colour + "', '" + colour_EN + "', '" + rank_name + "')");


                st.close();// close statment
                conexion.close();
            }// close conexion with DB
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    //if confirm is false, list all the registers to delete
    //if confirm is true, delete all the registers
    public static String rankDelete(String[] id, boolean confirm) {
        String result = "";
        try {

            Class.forName(className).newInstance();
            Connection conn = DriverManager.getConnection(host + dataBase, user, password);

            if (!confirm) { //list the registers

                result = "<h2>Are this the ranks that you want to delete?</h2>" +
                        "<table >" +
                        "<tr>" +
                        "<td> id </td>" +
                        "<td> color </td>" +
                        "<td> color_en </td>" +
                        "<td> rank_name</td>" +
                        "</tr>";

                int temp;

                for (int i = 0; i < id.length; i++) { //read the array
                    Statement st = conn.createStatement();
                    temp = Integer.parseInt(id[i]);

                    ResultSet rs = st.executeQuery(
                            "SELECT * FROM rank WHERE id = '" + temp + "'"); //search the regsiter wich id is the same that id[i]
                    rs.next();

                    Rank rank = new Rank(); //save the register in the rankList
                    rank.setId(rs.getInt("id"));
                    rank.setColour(rs.getString("colour"));
                    rank.setColour_en(rs.getString("colour_en"));
                    rank.setRank_name(rs.getString("rank_name"));

                    result = result + "<tr>"; //save the rank in the string result
                    result = result + "<td>" + rank.getId() + "</td>";
                    result = result + "<td>" + rank.getColour() + "</td>";
                    result = result + "<td>" + rank.getColour_en() + "</td>";
                    result = result + "<td>" + rank.getRank_name() + "</td>";
                    result = result + "</tr>";

                    rs.close(); //close query sql
                    st.close();// close statment
                }

                result = result +  //form for accept or edit the list of registers to delete
                                "</table> " +
                                "<form method=\"post\" action=\"deleteRank.jsp\" name=\"ConfirmDeleteRank\">" +
                                "<input type=\"submit\" name=\"accept\" value=\"Accept\">" +
                                "<input type=\"submit\" name=\"edit\" value=\"Edit\">" +
                                "</form>";

                conn.close(); // close conexiion with DB

            }

            Class.forName(className).newInstance();
            Connection connect = DriverManager.getConnection(host + dataBase, user, password);

            Statement stt = connect.createStatement();

            if (confirm) { // if the list of registers is correct, confirm is true
                for (int i = 0; i < id.length; i++) { //read the array
                    stt.executeUpdate( //delete the register which id is the same that id[i]
                            "DELETE FROM rank " +
                            "WHERE id = '" + id[i] + "'");
                }
                result = "Save Succesfull";
            }
            stt.close();
            connect.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
        return result;
    }

    // send array of string where I can obtain all the arrays to delete.
    public static String chooseRank() {

        LinkedList<Rank> RanksList = new LinkedList<Rank>();
        String result = "";

        try {

            Class.forName(className).newInstance();
            Connection conexion = DriverManager.getConnection(host + dataBase, user, password);
            Statement st = conexion.createStatement();
            ResultSet rst = st.executeQuery("select * from rank");
            while (rst.next()) // while exist more register I save in RanksList
            {
                Rank rank = new Rank();
                rank.setId(rst.getInt("id"));
                rank.setColour(rst.getString("colour"));
                rank.setColour_en(rst.getString("colour_en"));
                rank.setRank_name(rst.getString("rank_name"));
                RanksList.add(rank); //add rank to the list
            }

            rst.close(); //close query sql
            st.close();// close statment
            conexion.close(); // close conexion with DB
            result ="<form method=\"post\" action=\"confirmDeleteRank.jsp\" name=\"formDeleteRank\">" +
                    "<h1>Content of table rank</h1>" +
                    "<table >" +
                    "<tr>" +
                    "<td>Choose</td>" +
                    "<td> id </td>" +
                    "<td> color </td>" +
                    "<td> color_en </td>" +
                    "<td> rank_name</td>" +
                    "</tr>";

            for (int i = 0; i < RanksList.size(); i++) {
                result = result + "<tr>";
                result = result + "<td> <input type=\"checkbox\" name=\"id\" value=\"" + RanksList.get(i).getId() + "\"></td>";
                result = result + "<td>" + RanksList.get(i).getId() + "</td>";
                result = result + "<td>" + RanksList.get(i).getColour() + "</td>";
                result = result + "<td>" + RanksList.get(i).getColour_en() + "</td>";
                result = result + "<td>" + RanksList.get(i).getRank_name() + "</td>";
                result = result + "</tr>";
            }

            result = result +
                    "</table> " +
                    "<input type=\"submit\" name=\"delete\" value=\"Delete\">" +
                    "</form>";

        } catch (Exception e) {
            e.printStackTrace();
        }

        return result;
    }

    /*public static void main(String[] args) {

    //LinkedList<Rank> RanksList = new LinkedList<Rank>();
    int id = 31;
    String colour = "esto";
    String colour_EN = "";
    String rank_name = "lo mejor";
    String[] ids = {"27", "28", "29"};

    //rankUpdate(id, colour,colour_EN, rank_name);
    System.out.println(rankDelete(ids, true));
    //System.out.println(findRanks(id, colour, colour_EN, rank_name));
    //System.out.println(id + "  " + colour + "  " + colour_EN + "  " + rank_name);
    //rankConsult.rankDelete(id);
    //String list = rankConsult.getRanks();
    //System.out.println(rankResult(RanksList));

    }*/
}